<?
 $startTime=microtime(true);

 $_path["root"]="../../../../../";
 require($_path["root"]."include.php");

 //hack for JAS project, switch to correct jses+path
 if($_jses["project"]=="jas"&&isset($_jses["currentProject"])&&$_jses["currentProject"]!="jas")
 {
  $_jasPath=$_path;
  require($_jasPath["project"]["include"]."switch.php"); //currentProject
 }

 require_once($_path["include"]."data.php");
 require_once($_path["include"]."plugin.php");
 require_once($_path["include"]."template.php");

 //init average time
 if(!isset($_jses["automagic"]))
 {
  $_jses["automagic"]=Array();
  $_jses["automagic"]["time"]=0;
  $_jses["automagic"]["weigth"]=0;
 }

 //initialize plugin
 $plugin=new Plugin("photoalbum");

 if(!$plugin->isEnabled())
 {
  $plugin->e->add("Plugin ".$plugin->name." is disabled", "error");
  print $plugin->e->show();
  exit;
 }

 //initialize template
 $template=new Template($plugin->path["templates"]."automagic.html");
 $template->exactPath=false;

 if($template->e->any("fatal"))
 {
  print $template->e->show();
  exit;
 }

 $values=Array();

 //handle request
 if($catnr=request("pictures")) //auto add pictures
 {
  if($template->search("album", true, true, false))
  {
   $d=Data::cache("photoalbum_categories", "view", "item");
   $d->setValue("nr", $catnr);

   $d->setShowFields("name");

   if($d->get()&&$d->next())
    $values["album"]=$d->v["name"];
  }

  $d=Data::cache("photoalbum_pictures", "add", "item", Array("skipPostInit" => true));

  //get todo file list
  $d->setValue("catnr", $catnr);
  $d->postInit();

  $todo=$d->listOptions["file"];

  //get full file list
  $d->setFileDir("file", $d->field["file"]["localpath"]["directory"]);
  $all=$d->listOptions["file"];

  $total=sizeof($all);
  $current=$total-sizeof($todo);

  if($todo) //add entry
  {
   $current++;

   $d->setValue("file", $todo[0]);

   if(!$d->submit())
    $plugin->e->add($d->e);

   $values["file"]=$d->getValue("file");
  }

  if($current==$total)
  {
   $plugin->e->add("Photo album automagic done", "note");
   $template->set("script", "", true, true); //remove reload script
  }

  $percentage=round(100*($current/$total));
 }
 else
  $plugin->e->add("Unknown photo album automagic action", "error");

 //set default project style sheet
 $template->setAttribute("html->head->link", "href", $_path["project"]["style"]."default.css");

 //set template values
 if($plugin->e->any())
  $values["error"]=$plugin->e->show();

 if(!$plugin->e->any("fatal"))
 {
  $values["percentage"]=$percentage;

  $values["entry"]=$current;
  $values["total"]=$total;

  //calculate time
  $time=microtime(true)-$startTime;

  //calculate average time
  $tmp=$_jses["automagic"]["time"]*$_jses["automagic"]["weigth"];
  $tmp+=$time;

  if($_jses["automagic"]["weigth"]<10) //don't save more than 10 times
  {
   $_jses["automagic"]["weigth"]++;
   $_jses["automagic"]["time"]=$tmp/$_jses["automagic"]["weigth"];
  }
  else
   $_jses["automagic"]["time"]=$tmp/($_jses["automagic"]["weigth"]+1);

  //calculate total estimated time
  $timeLeft=$_jses["automagic"]["time"]*($total-$current);
  $totalTime=$_jses["automagic"]["time"]*$total;

  $values["time"]=round($time, 3);
  $values["timeLeft"]=gmdate("i:s", $timeLeft);
  $values["totalTime"]=gmdate("i:s", $totalTime);
 }
 else
 {
  $values["percentage"]=0;

  $values["entry"]=0;
  $values["total"]=0;

  $values["time"]=round(0, 3);
  $values["timeLeft"]=gmdate("i:s", 0);
  $values["totalTime"]=gmdate("i:s", 0);

  $template->set("script", "", true, true); //remove reload script
 }

 //set values
 $template->set("html->body", $values, true, true);

 //output template
 print $template->output();
?>
